#!/usr/bin/perl
use strict;
use warnings;

my $cypher = <<'EOF';
0680: A7 4E 53 79 07 E4 48 FB 0F DF 49 95 40 53 E0 25 |.NSy..H...I.@S.%|
0690: 04 84 7B 36 60 B4 C4 29 D3 12 E5 F3 0E A5 D2 ED |..{6`..)........|
06A0: 81 21 3D D0 B4 AF 1D 2A CB B4 BB 2F 2E 7E AA 34 |.!=....*.../.~.4|
06B0: 6D 4F 26 32 FE BA 93 AF F2 F9 BE 2A 76 06 F7 92 |mO&2.......*v...|
06C0: CC 92 9E 9B 13 D4 ED 34 9A 1C 53 B7 6D 47 B5 C0 |.......4..S.mG..|
06D0: 10 22 B4 8A FE 64 88 20 39 F0 9A A6 04 94 2B 5F |."...d. 9.....+_|
06E0: 7F 55 50 B7 06 42 94 EE B7 0E EE 76 E1 B9 E3 BA |.UP..B.....v....|
06F0: 57 12 23 A9 F2 7D 87 76 AB 0D 53 BF E0 D6 59 D2 |W.#..}.v..S...Y.|
EOF

$cypher =~ s/(^....: |\|.*?\|)//gm;

my @cypher = map hex, split " ", $cypher;

$ARGV[0] or die "Usage: decode IN > OUT\n";

open my $fh, $ARGV[0] or die "ERROR: Cannot open $ARGV[0]: $!\n";

read $fh, my $header, 16;
print $header;

while (not eof $fh) {
    read $fh, my $sector, 128;

    my @bytes = map ord, split //, $sector;

    $bytes[$_] ^= $cypher[$_] for 0 .. $#bytes;

    print map chr, @bytes;
}

if (1) {
    for my $val (0x36, 0xff) {
        for (my $i = 0; $i < 128; ++$i) {
            if (($i & 15) == 0) {
                printf "\n%02x: ", $i;
            } else {
                print " ";
            }
            printf "%02x", $cypher[$i]^$val;
        }
        print "\n";
    }
}
