#!/usr/bin/perl
use strict;
use warnings;

my $cypher = <<'EOF';
0680: A7 4E 53 79 07 E4 48 FB 0F DF 49 95 40 53 E0 25 |.NSy..H...I.@S.%|
0690: 04 84 7B 36 60 B4 C4 29 D3 12 E5 F3 0E A5 D2 ED |..{6`..)........|
06A0: 81 21 3D D0 B4 AF 1D 2A CB B4 BB 2F 2E 7E AA 34 |.!=....*.../.~.4|
06B0: 6D 4F 26 32 FE BA 93 AF F2 F9 BE 2A 76 06 F7 92 |mO&2.......*v...|
06C0: CC 92 9E 9B 13 D4 ED 34 9A 1C 53 B7 6D 47 B5 C0 |.......4..S.mG..|
06D0: 10 22 B4 8A FE 64 88 20 39 F0 9A A6 04 94 2B 5F |."...d. 9.....+_|
06E0: 7F 55 50 B7 06 42 94 EE B7 0E EE 76 E1 B9 E3 BA |.UP..B.....v....|
06F0: 57 12 23 A9 F2 7D 87 76 AB 0D 53 BF E0 D6 59 D2 |W.#..}.v..S...Y.|
EOF

my $encoded = <<'EOF';
0400: A5 45 58 75 0B E9 45 F5 01 D0 46 85 50 58 EB 29 |.EXu..E...F.PX.)|
0410: 08 7B 7F 32 64 B0 C0 2D D7 16 E1 F7 0A A1 D6 E9 |.{.2d..-........|
0420: 85 25 39 D4 B0 AB 19 2E 34 B4 BA 2D 2D 7A AF 32 |.%9.....4..--z.2|
0430: 6A 47 2F 38 01 08 93 AC FE F4 B0 25 66 17 E5 81 |jG/8.......%f...|
0440: D8 87 88 8C 0B CD F7 2F 86 E3 E1 B7 68 58 95 E1 |......./....hX..|
0450: 32 01 90 AF D8 43 A0 09 13 0F 9A A6 04 B9 05 70 |2....C.........p|
0460: 4F 64 62 84 35 71 A7 DD 84 3D DD 45 D2 8A D0 89 |Odb.5q...=.E....|
0470: 64 21 10 9A C1 82 35 76 AD 3B 65 89 D6 E0 6F E4 |d!....5v.;e...o.|
EOF

my @cypher = split /\n/, $cypher;
my @encoded = split /\n/, $encoded;

while (@cypher) {
    my $cline = shift @cypher;
    my $eline = shift @encoded;

    $eline =~ /(....):/;
    my $addr = $1 || "0000";

    s/....: (.*) \|.*/$1/ for $cline, $eline;

    my @cs = split " ", $cline;
    my @es = split " ", $eline;

    my @ds;
    for (my $i = 0; $i < @cs; ++$i) {
        $ds[$i] = hex($es[$i]) ^ hex($cs[$i]);
    }

    print "$addr: ", (join " ", map { sprintf "%02X", $_ } @ds), "\n";
}
